> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/software-delivery-agent-apis/gitops/application-set.md).

# Application Set

## Update updates an applicationset

> Update applicationset.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/applicationset":{"post":{"summary":"Update updates an applicationset","description":"Update applicationset.","operationId":"ApplicationSetService_Create","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1ApplicationSet"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"$ref":"#/components/requestBodies/applicationsApplicationSetCreateRequest"},"tags":["ApplicationSet"]}}},"components":{"schemas":{"servicev1ApplicationSet":{"type":"object","properties":{"identifier":{"type":"string","description":"UUID for the Application Set."},"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"owner":{"type":"string"},"appset":{"$ref":"#/components/schemas/applicationsApplicationSet"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the ApplicationSet."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for ApplicationSets."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"applicationsApplicationSet":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSetSpec"},"status":{"$ref":"#/components/schemas/applicationsApplicationSetStatus"}},"description":"ApplicationSet is a set of Application resources."},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsApplicationSetSpec":{"type":"object","properties":{"goTemplate":{"type":"boolean"},"generators":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetGenerator"}},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"syncPolicy":{"$ref":"#/components/schemas/applicationsApplicationSetSyncPolicy"},"strategy":{"$ref":"#/components/schemas/applicationsApplicationSetStrategy"},"preservedFields":{"$ref":"#/components/schemas/applicationsApplicationPreservedFields"},"goTemplateOptions":{"type":"array","items":{"type":"string"}},"applyNestedSelectors":{"type":"boolean","description":"ApplyNestedSelectors enables selectors defined within the generators of two level-nested matrix or merge generators\nDeprecated: This field is ignored, and the behavior is always enabled. The field will be removed in a future\nversion of the ApplicationSet CRD."},"ignoreApplicationDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetResourceIgnoreDifferences"}},"templatePatch":{"type":"string"}},"description":"ApplicationSetSpec represents a class of application set state."},"applicationsApplicationSetGenerator":{"type":"object","properties":{"list":{"$ref":"#/components/schemas/applicationsListGenerator"},"clusters":{"$ref":"#/components/schemas/applicationsClusterGenerator"},"git":{"$ref":"#/components/schemas/applicationsGitGenerator"},"scmProvider":{"$ref":"#/components/schemas/applicationsSCMProviderGenerator"},"clusterDecisionResource":{"$ref":"#/components/schemas/applicationsDuckTypeGenerator"},"pullRequest":{"$ref":"#/components/schemas/applicationsPullRequestGenerator"},"matrix":{"$ref":"#/components/schemas/applicationsMatrixGenerator"},"merge":{"$ref":"#/components/schemas/applicationsMergeGenerator"},"selector":{"$ref":"#/components/schemas/v1LabelSelector"},"plugin":{"$ref":"#/components/schemas/applicationsPluginGenerator"}},"description":"ApplicationSetGenerator represents a generator at the top level of an ApplicationSet."},"applicationsListGenerator":{"type":"object","properties":{"elements":{"type":"array","items":{"$ref":"#/components/schemas/v1JSON"},"title":"+kubebuilder:validation:Optional"},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"elementsYaml":{"type":"string"}},"title":"ListGenerator include items info"},"v1JSON":{"type":"object","properties":{"raw":{"type":"string","format":"byte"}},"description":"JSON represents any valid JSON value.\nThese types are supported: bool, int64, float64, string, []interface{}, map[string]interface{} and nil."},"applicationsApplicationSetTemplate":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/applicationsApplicationSetTemplateMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSpec"}},"title":"ApplicationSetTemplate represents argocd ApplicationSpec"},"applicationsApplicationSetTemplateMeta":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"labels":{"type":"object","additionalProperties":{"type":"string"}},"annotations":{"type":"object","additionalProperties":{"type":"string"}},"finalizers":{"type":"array","items":{"type":"string"}}},"title":"ApplicationSetTemplateMeta represents the Argo CD application fields that may\nbe used for Applications generated from the ApplicationSet (based on metav1.ObjectMeta)"},"applicationsApplicationSpec":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"destination":{"$ref":"#/components/schemas/applicationsApplicationDestination"},"project":{"type":"string","description":"Project is a reference to the project this application belongs to.\nThe empty string means that application belongs to the 'default' project."},"syncPolicy":{"$ref":"#/components/schemas/applicationsSyncPolicy"},"ignoreDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceIgnoreDifferences"},"title":"IgnoreDifferences is a list of resources and their fields which should be ignored during comparison"},"info":{"type":"array","items":{"$ref":"#/components/schemas/applicationsInfo"},"title":"Info contains a list of information (URLs, email addresses, and plain text) that relates to the application"},"revisionHistoryLimit":{"type":"string","format":"int64","description":"RevisionHistoryLimit limits the number of items kept in the application's revision history, which is used for informational purposes as well as for rollbacks to previous versions.\nThis should only be changed in exceptional circumstances.\nSetting to zero will store no history. This will reduce storage used.\nIncreasing will increase the space used to store the history, so we do not recommend increasing it.\nDefault is 10."},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the location of the application's manifests or chart"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"description":"ApplicationSpec represents desired application state. Contains link to repository with application definition and additional parameters link definition revision."},"applicationsApplicationSource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the repository (Git or Helm) that contains the application manifests"},"path":{"type":"string","description":"Path is a directory path within the Git repository, and is only valid for applications sourced from Git."},"targetRevision":{"type":"string","description":"TargetRevision defines the revision of the source to sync the application to.\nIn case of Git, this can be commit, tag, or branch. If omitted, will equal to HEAD.\nIn case of Helm, this is a semver tag for the Chart's version."},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"ksonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceKsonnet"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"},"chart":{"type":"string","description":"Chart is a Helm chart name, and must be specified for applications sourced from a Helm repo."},"ref":{"type":"string","description":"Ref is reference to another source within sources field. This field will not be used if used with a `source` tag."},"name":{"type":"string","description":"Name is used to refer to a source and is displayed in the UI. It is used in multi-source Applications."},"tagPrefix":{"type":"string","description":"TagPrefix filters git tags to only those with this prefix before evaluating targetRevision as a semver constraint.\nThe prefix is stripped from tag names before comparison and re-added to the resolved version.\nFor example, with tagPrefix \"component-b/\" and targetRevision \"1.0.*\", tags like \"component-b/1.0.0\" and\n\"component-b/1.0.1\" are candidates, and the constraint resolves to \"component-b/1.0.1\"."}},"title":"ApplicationSource contains all information about the source of an application"},"applicationsApplicationSourceHelm":{"type":"object","properties":{"valueFiles":{"type":"array","items":{"type":"string"},"title":"ValuesFiles is a list of Helm value files to use when generating a template"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmParameter"},"title":"Parameters is a list of Helm parameters which are passed to the helm template command upon manifest generation"},"releaseName":{"type":"string","title":"ReleaseName is the Helm release name to use. If omitted it will use the application name"},"values":{"type":"string","title":"Values specifies Helm values to be passed to helm template, typically defined as a block"},"fileParameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmFileParameter"},"title":"FileParameters are file parameters to the helm template"},"version":{"type":"string","title":"Version is the Helm version to use for templating (either \"2\" or \"3\")"},"passCredentials":{"type":"boolean","title":"PassCredentials pass credentials to all domains (Helm's --pass-credentials)"},"ignoreMissingValueFiles":{"type":"boolean","title":"IgnoreMissingValueFiles prevents helm template from failing when valueFiles do not exist locally by not appending them to helm template --values"},"skipCrds":{"type":"boolean","title":"SkipCrds skips custom resource definition installation step (Helm's --skip-crds)"},"valuesObject":{"type":"object","title":"ValuesObject specifies Helm values to be passed to helm template, defined as a map. This takes precedence over Values.\n+kubebuilder:pruning:PreserveUnknownFields"},"namespace":{"type":"string","description":"Namespace is an optional namespace to template with. If left empty, defaults to the app's destination namespace."},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"skipTests":{"type":"boolean","description":"SkipTests skips test manifest installation step (Helm's --skip-tests)."},"skipSchemaValidation":{"type":"boolean","title":"SkipSchemaValidation skips JSON schema validation (Helm's --skip-schema-validation)"}},"title":"ApplicationSourceHelm holds helm specific options\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsHelmParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"value":{"type":"string","title":"Value is the value for the Helm parameter"},"forceString":{"type":"boolean","title":"ForceString determines whether to tell Helm to interpret booleans and numbers as strings"}},"title":"HelmParameter is a parameter that's passed to helm template during manifest generation"},"applicationsHelmFileParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"path":{"type":"string","title":"Path is the path to the file containing the values for the Helm parameter"}},"title":"HelmFileParameter is a file parameter that's passed to helm template during manifest generation"},"applicationsApplicationSourceKustomize":{"type":"object","properties":{"namePrefix":{"type":"string","title":"NamePrefix overrides the namePrefix in the kustomization.yaml for Kustomize apps"},"nameSuffix":{"type":"string","title":"NameSuffix overrides the nameSuffix in the kustomization.yaml for Kustomize apps"},"images":{"type":"array","items":{"type":"string"},"title":"Images is a list of Kustomize image override specifications"},"commonLabels":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonLabels is a list of additional labels to add to rendered manifests"},"version":{"type":"string","title":"Version controls which version of Kustomize to use for rendering manifests"},"commonAnnotations":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonAnnotations is a list of additional annotations to add to rendered manifests"},"forceCommonLabels":{"type":"boolean","title":"ForceCommonLabels specifies whether to force applying common labels to resources for Kustomize apps"},"forceCommonAnnotations":{"type":"boolean","title":"ForceCommonAnnotations specifies whether to force applying common annotations to resources for Kustomize apps"},"namespace":{"type":"string","title":"Namespace sets the namespace that Kustomize adds to all resources"},"commonAnnotationsEnvsubst":{"type":"boolean","title":"CommonAnnotationsEnvsubst specifies whether to apply env variables substitution for annotation values"},"replicas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizeReplicas"},"title":"Replicas is a list of Kustomize Replicas override specifications"},"patches":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizePatch"},"title":"Patches is a list of Kustomize patches"},"components":{"type":"array","items":{"type":"string"},"title":"Components specifies a list of kustomize components to add to the kustomization before building"},"labelWithoutSelector":{"type":"boolean","title":"LabelWithoutSelector specifies whether to apply common labels to resource selectors or not"},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"ignoreMissingComponents":{"type":"boolean","title":"IgnoreMissingComponents prevents kustomize from failing when components do not exist locally by not appending them to kustomization file"},"labelIncludeTemplates":{"type":"boolean","title":"LabelIncludeTemplates specifies whether to apply common labels to resource templates or not"}},"title":"ApplicationSourceKustomize holds options specific to an Application source specific to Kustomize"},"applicationsKustomizeReplicas":{"type":"object","properties":{"count":{"type":"string","title":"Number of replicas"},"name":{"type":"string","title":"Name of Deployment or StatefulSet"}}},"applicationsKustomizePatch":{"type":"object","properties":{"path":{"type":"string"},"patch":{"type":"string"},"target":{"$ref":"#/components/schemas/applicationsKustomizeSelector"},"options":{"type":"object","additionalProperties":{"type":"boolean"}}}},"applicationsKustomizeSelector":{"type":"object","properties":{"resId":{"$ref":"#/components/schemas/applicationsKustomizeResId"},"annotationSelector":{"type":"string"},"labelSelector":{"type":"string"}}},"applicationsKustomizeResId":{"type":"object","properties":{"gvk":{"$ref":"#/components/schemas/applicationsKustomizeGvk"},"name":{"type":"string"},"namespace":{"type":"string"}}},"applicationsKustomizeGvk":{"type":"object","properties":{"group":{"type":"string"},"version":{"type":"string"},"kind":{"type":"string"}}},"applicationsApplicationSourceKsonnet":{"type":"object","properties":{"environment":{"type":"string","title":"Environment is a ksonnet application environment name"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKsonnetParameter"},"title":"Parameters are a list of ksonnet component parameter override values"}},"title":"ApplicationSourceKsonnet holds ksonnet specific options"},"applicationsKsonnetParameter":{"type":"object","properties":{"component":{"type":"string"},"name":{"type":"string"},"value":{"type":"string"}},"title":"KsonnetParameter is a ksonnet component parameter"},"applicationsApplicationSourceDirectory":{"type":"object","properties":{"recurse":{"type":"boolean","title":"Recurse specifies whether to scan a directory recursively for manifests"},"jsonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceJsonnet"},"exclude":{"type":"string","title":"Exclude contains a glob pattern to match paths against that should be explicitly excluded from being used during manifest generation"},"include":{"type":"string","title":"Include contains a glob pattern to match paths against that should be explicitly included during manifest generation"}},"title":"ApplicationSourceDirectory holds options for applications of type plain YAML or Jsonnet"},"applicationsApplicationSourceJsonnet":{"type":"object","properties":{"extVars":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"ExtVars is a list of Jsonnet External Variables"},"tlas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"TLAS is a list of Jsonnet Top-level Arguments"},"libs":{"type":"array","items":{"type":"string"},"title":"Additional library search dirs"}},"title":"ApplicationSourceJsonnet holds options specific to applications of type Jsonnet"},"applicationsJsonnetVar":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"},"code":{"type":"boolean"}},"title":"JsonnetVar represents a variable to be passed to jsonnet during manifest generation"},"applicationsApplicationSourcePlugin":{"type":"object","properties":{"name":{"type":"string"},"env":{"type":"array","items":{"$ref":"#/components/schemas/applicationsEnvEntry"}},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSourcePluginParameter"}}},"title":"ApplicationSourcePlugin holds options specific to config management plugins"},"applicationsEnvEntry":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the variable, usually expressed in uppercase"},"value":{"type":"string","title":"Value is the value of the variable"}},"title":"EnvEntry represents an entry in the application's environment"},"applicationsApplicationSourcePluginParameter":{"type":"object","properties":{"name":{"type":"string","description":"Name is the name identifying a parameter."},"string":{"type":"string","description":"String_ is the value of a string type parameter."},"map":{"$ref":"#/components/schemas/applicationsOptionalMap"},"array":{"$ref":"#/components/schemas/applicationsOptionalArray"}}},"applicationsOptionalMap":{"type":"object","properties":{"map":{"type":"object","additionalProperties":{"type":"string"},"title":"Map is the value of a map type parameter.\n+optional"}}},"applicationsOptionalArray":{"type":"object","properties":{"array":{"type":"array","items":{"type":"string"},"title":"Array is the value of an array type parameter.\n+optional"}}},"applicationsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"applicationsSyncPolicy":{"type":"object","properties":{"automated":{"$ref":"#/components/schemas/applicationsSyncPolicyAutomated"},"syncOptions":{"type":"array","items":{"type":"string"},"title":"Options allow you to specify whole app sync-options"},"retry":{"$ref":"#/components/schemas/applicationsRetryStrategy"},"managedNamespaceMetadata":{"$ref":"#/components/schemas/applicationsManagedNamespaceMetadata"}},"title":"SyncPolicy controls when a sync will be performed in response to updates in git"},"applicationsSyncPolicyAutomated":{"type":"object","properties":{"prune":{"type":"boolean","title":"Prune specifies whether to delete resources from the cluster that are not found in the sources anymore as part of automated sync (default: false)"},"selfHeal":{"type":"boolean","title":"SelfHeal specifes whether to revert resources back to their desired state upon modification in the cluster (default: false)"},"allowEmpty":{"type":"boolean","title":"AllowEmpty allows apps have zero live resources (default: false)"},"enabled":{"type":"boolean","title":"Enable allows apps to explicitly control automated sync"}},"title":"SyncPolicyAutomated controls the behavior of an automated sync"},"applicationsRetryStrategy":{"type":"object","properties":{"limit":{"type":"string","format":"int64","description":"Limit is the maximum number of attempts for retrying a failed sync. If set to 0, no retries will be performed."},"backoff":{"$ref":"#/components/schemas/applicationsBackoff"},"refresh":{"type":"boolean","title":"Refresh indicates if the latest revision should be used on retry instead of the initial one (default: false)"}},"title":"RetryStrategy contains information about the strategy to apply when a sync failed"},"applicationsBackoff":{"type":"object","properties":{"duration":{"type":"string","title":"Duration is the amount to back off. Default unit is seconds, but could also be a duration (e.g. \"2m\", \"1h\")"},"factor":{"type":"string","format":"int64","title":"Factor is a factor to multiply the base duration after each failed retry"},"maxDuration":{"type":"string","title":"MaxDuration is the maximum amount of time allowed for the backoff strategy"}},"title":"Backoff is the backoff strategy to use on subsequent retries for failing syncs"},"applicationsManagedNamespaceMetadata":{"type":"object","properties":{"labels":{"type":"object","additionalProperties":{"type":"string"}},"annotations":{"type":"object","additionalProperties":{"type":"string"}}}},"applicationsResourceIgnoreDifferences":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"},"namespace":{"type":"string"},"jsonPointers":{"type":"array","items":{"type":"string"}},"jqPathExpressions":{"type":"array","items":{"type":"string"}},"managedFieldsManagers":{"type":"array","items":{"type":"string"},"title":"ManagedFieldsManagers is a list of trusted managers. Fields mutated by those managers will take precedence over the\ndesired state defined in the SCM and won't be displayed in diffs"}},"description":"ResourceIgnoreDifferences contains resource filter and list of json paths which should be ignored during comparison with live state."},"applicationsInfo":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"}}},"applicationsSourceHydrator":{"type":"object","properties":{"drySource":{"$ref":"#/components/schemas/applicationsDrySource"},"syncSource":{"$ref":"#/components/schemas/applicationsSyncSource"},"hydrateTo":{"$ref":"#/components/schemas/applicationsHydrateTo"}},"description":"SourceHydrator specifies a dry \"don't repeat yourself\" source for manifests, a sync source from which to sync\nhydrated manifests, and an optional hydrateTo location to act as a \"staging\" aread for hydrated manifests."},"applicationsDrySource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the git repository that contains the application manifests"},"targetRevision":{"type":"string","title":"TargetRevision defines the revision of the source to hydrate"},"path":{"type":"string","title":"Path is a directory path within the Git repository where the manifests are located"},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"}},"description":"DrySource specifies a location for dry \"don't repeat yourself\" manifest source information."},"applicationsSyncSource":{"type":"object","properties":{"targetBranch":{"type":"string","description":"TargetBranch is the branch from which hydrated manifests will be synced.\nIf HydrateTo is not set, this is also the branch to which hydrated manifests are committed."},"path":{"type":"string","description":"Path is a directory path within the git repository where hydrated manifests should be committed to and synced\nfrom. The Path should never point to the root of the repo. If hydrateTo is set, this is just the path from which\nhydrated manifests will be synced.\n\n+kubebuilder:validation:Required\n+kubebuilder:validation:MinLength=1\n+kubebuilder:validation:Pattern=`^.{2,}|[^./]$`"},"repoURL":{"type":"string","description":"RepoURL is the URL to the git repository that contains the hydrated manifests. If not set, defaults to\nthe DrySource.RepoURL."}},"description":"SyncSource specifies a location from which hydrated manifests may be synced. If RepoURL is not set, it is assumed\nto be the same as the associated DrySource config in the SourceHydrator."},"applicationsHydrateTo":{"type":"object","properties":{"targetBranch":{"type":"string","title":"TargetBranch is the branch to which hydrated manifests should be committed"}},"description":"HydrateTo specifies a branch to which hydrated manifests should be pushed as a \"staging area\" before being moved to\nthe SyncSource. The repository and path are inherited from SyncSource."},"applicationsClusterGenerator":{"type":"object","properties":{"selector":{"$ref":"#/components/schemas/v1LabelSelector"},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"values":{"type":"object","additionalProperties":{"type":"string"},"title":"Values contains key/value pairs which are passed directly as parameters to the template"},"flatList":{"type":"boolean","title":"returns the clusters a single 'clusters' value in the template"}},"description":"ClusterGenerator defines a generator to match against clusters registered with ArgoCD."},"v1LabelSelector":{"type":"object","properties":{"matchLabels":{"type":"object","additionalProperties":{"type":"string"},"title":"matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels\nmap is equivalent to an element of matchExpressions, whose key field is \"key\", the\noperator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n+optional"},"matchExpressions":{"type":"array","items":{"$ref":"#/components/schemas/v1LabelSelectorRequirement"},"title":"matchExpressions is a list of label selector requirements. The requirements are ANDed.\n+optional\n+listType=atomic"}},"title":"A label selector is a label query over a set of resources. The result of matchLabels and\nmatchExpressions are ANDed. An empty label selector matches all objects. A null\nlabel selector matches no objects.\n+structType=atomic"},"v1LabelSelectorRequirement":{"type":"object","properties":{"key":{"type":"string","description":"key is the label key that the selector applies to."},"operator":{"type":"string","description":"operator represents a key's relationship to a set of values.\nValid operators are In, NotIn, Exists and DoesNotExist."},"values":{"type":"array","items":{"type":"string"},"title":"values is an array of string values. If the operator is In or NotIn,\nthe values array must be non-empty. If the operator is Exists or DoesNotExist,\nthe values array must be empty. This array is replaced during a strategic\nmerge patch.\n+optional\n+listType=atomic"}},"description":"A label selector requirement is a selector that contains values, a key, and an operator that\nrelates the key and values."},"applicationsGitGenerator":{"type":"object","properties":{"repoURL":{"type":"string"},"directories":{"type":"array","items":{"$ref":"#/components/schemas/applicationsGitDirectoryGeneratorItem"}},"files":{"type":"array","items":{"$ref":"#/components/schemas/applicationsGitFileGeneratorItem"}},"revision":{"type":"string"},"requeueAfterSeconds":{"type":"string","format":"int64"},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"pathParamPrefix":{"type":"string"},"values":{"type":"object","additionalProperties":{"type":"string"},"title":"Values contains key/value pairs which are passed directly as parameters to the template"}}},"applicationsGitDirectoryGeneratorItem":{"type":"object","properties":{"path":{"type":"string"},"exclude":{"type":"boolean"}}},"applicationsGitFileGeneratorItem":{"type":"object","properties":{"path":{"type":"string"},"exclude":{"type":"boolean"}}},"applicationsSCMProviderGenerator":{"type":"object","properties":{"github":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorGithub"},"gitlab":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorGitlab"},"bitbucket":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorBitbucket"},"bitbucketServer":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorBitbucketServer"},"gitea":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorGitea"},"azureDevOps":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorAzureDevOps"},"filters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorFilter"},"description":"Filters for which repos should be considered."},"cloneProtocol":{"type":"string","description":"Which protocol to use for the SCM URL. Default is provider-specific but ssh if possible. Not all providers\nnecessarily support all protocols."},"requeueAfterSeconds":{"type":"string","format":"int64","description":"Standard parameters."},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"values":{"type":"object","additionalProperties":{"type":"string"},"title":"Values contains key/value pairs which are passed directly as parameters to the template"},"awsCodeCommit":{"$ref":"#/components/schemas/applicationsSCMProviderGeneratorAWSCodeCommit"}},"description":"SCMProviderGenerator defines a generator that scrapes a SCMaaS API to find candidate repos."},"applicationsSCMProviderGeneratorGithub":{"type":"object","properties":{"organization":{"type":"string","description":"GitHub org to scan. Required."},"api":{"type":"string","description":"The GitHub API URL to talk to. If blank, use https://api.github.com/."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"appSecretName":{"type":"string","description":"AppSecretName is a reference to a GitHub App repo-creds secret."},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."},"excludeArchivedRepos":{"type":"boolean","description":"Exclude repositories that are archived."}},"description":"SCMProviderGeneratorGithub defines connection info specific to GitHub."},"applicationsSecretRef":{"type":"object","properties":{"secretName":{"type":"string"},"key":{"type":"string"}},"description":"SecretRef struct for a reference to a secret key."},"applicationsSCMProviderGeneratorGitlab":{"type":"object","properties":{"group":{"type":"string","description":"Gitlab group to scan. Required.  You can use either the project id (recommended) or the full namespaced path."},"includeSubgroups":{"type":"boolean","title":"Recurse through subgroups (true) or scan only the base group (false).  Defaults to \"false\""},"api":{"type":"string","description":"The Gitlab API URL to talk to."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."},"insecure":{"type":"boolean","title":"Skips validating the SCM provider's TLS certificate - useful for self-signed certificates.; default: false"},"includeSharedProjects":{"type":"boolean","title":"When recursing through subgroups, also include shared Projects (true) or scan only the subgroups under same path (false).  Defaults to \"true\""},"topic":{"type":"string","description":"Filter repos list based on Gitlab Topic."},"caRef":{"$ref":"#/components/schemas/applicationsConfigMapKeyRef"},"includeArchivedRepos":{"type":"boolean","description":"Include repositories that are archived."}},"description":"SCMProviderGeneratorGitlab defines connection info specific to Gitlab."},"applicationsConfigMapKeyRef":{"type":"object","properties":{"configMapName":{"type":"string"},"key":{"type":"string"}},"description":"ConfigMapKeyRef struct for a reference to a configmap key."},"applicationsSCMProviderGeneratorBitbucket":{"type":"object","properties":{"owner":{"type":"string","description":"Bitbucket workspace to scan. Required."},"user":{"type":"string","title":"Bitbucket user to use when authenticating.  Should have a \"member\" role to be able to read all repositories and branches.  Required"},"appPasswordRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the main branch."}},"description":"SCMProviderGeneratorBitbucket defines connection info specific to Bitbucket Cloud (API version 2)."},"applicationsSCMProviderGeneratorBitbucketServer":{"type":"object","properties":{"project":{"type":"string","description":"Project to scan. Required."},"api":{"type":"string","description":"The Bitbucket Server REST API URL to talk to. Required."},"basicAuth":{"$ref":"#/components/schemas/applicationsBasicAuthBitbucketServer"},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."},"bearerToken":{"$ref":"#/components/schemas/applicationsBearerTokenBitbucket"},"insecure":{"type":"boolean","title":"Allow self-signed TLS / Certificates; default: false"},"caRef":{"$ref":"#/components/schemas/applicationsConfigMapKeyRef"}},"description":"SCMProviderGeneratorBitbucketServer defines connection info specific to Bitbucket Server."},"applicationsBasicAuthBitbucketServer":{"type":"object","properties":{"username":{"type":"string","title":"Username for Basic auth"},"passwordRef":{"$ref":"#/components/schemas/applicationsSecretRef"}},"description":"BasicAuthBitbucketServer defines the username/(password or personal access token) for Basic auth."},"applicationsBearerTokenBitbucket":{"type":"object","properties":{"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"}},"description":"BearerTokenBitbucket defines the Bearer token for BitBucket AppToken auth."},"applicationsSCMProviderGeneratorGitea":{"type":"object","properties":{"owner":{"type":"string","description":"Gitea organization or user to scan. Required."},"api":{"type":"string","description":"The Gitea URL to talk to. For example https://gitea.mydomain.com/."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."},"insecure":{"type":"boolean","title":"Allow self-signed TLS / Certificates; default: false"},"excludeArchivedRepos":{"type":"boolean","description":"Exclude repositories that are archived."}},"description":"SCMProviderGeneratorGitea defines a connection info specific to Gitea."},"applicationsSCMProviderGeneratorAzureDevOps":{"type":"object","properties":{"organization":{"type":"string","description":"Azure Devops organization. Required. E.g. \"my-organization\"."},"api":{"type":"string","description":"The URL to Azure DevOps. If blank, use https://dev.azure.com."},"teamProject":{"type":"string","description":"Azure Devops team project. Required. E.g. \"my-team\"."},"accessTokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."}},"description":"SCMProviderGeneratorAzureDevOps defines connection info specific to Azure DevOps."},"applicationsSCMProviderGeneratorFilter":{"type":"object","properties":{"repositoryMatch":{"type":"string","description":"A regex for repo names."},"pathsExist":{"type":"array","items":{"type":"string"},"description":"An array of paths, all of which must exist."},"pathsDoNotExist":{"type":"array","items":{"type":"string"},"description":"An array of paths, all of which must not exist."},"labelMatch":{"type":"string","description":"A regex which must match at least one label."},"branchMatch":{"type":"string","description":"A regex which must match the branch name."}},"description":"SCMProviderGeneratorFilter is a single repository filter.\nIf multiple filter types are set on a single struct, they will be AND'd together. All filters must\npass for a repo to be included."},"applicationsSCMProviderGeneratorAWSCodeCommit":{"type":"object","properties":{"tagFilters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsTagFilter"},"title":"TagFilters provides the tag filter(s) for repo discovery"},"role":{"type":"string","description":"Role provides the AWS IAM role to assume, for cross-account repo discovery\nif not provided, AppSet controller will use its pod/node identity to discover."},"region":{"type":"string","description":"Region provides the AWS region to discover repos.\nif not provided, AppSet controller will infer the current region from environment."},"allBranches":{"type":"boolean","description":"Scan all branches instead of just the default branch."}},"description":"SCMProviderGeneratorAWSCodeCommit defines connection info specific to AWS CodeCommit."},"applicationsTagFilter":{"type":"object","properties":{"key":{"type":"string"},"value":{"type":"string"}}},"applicationsDuckTypeGenerator":{"type":"object","properties":{"configMapRef":{"type":"string","title":"ConfigMapRef is a ConfigMap with the duck type definitions needed to retrieve the data\n             this includes apiVersion(group/version), kind, matchKey and validation settings\nName is the resource name of the kind, group and version, defined in the ConfigMapRef\nRequeueAfterSeconds is how long before the duckType will be rechecked for a change"},"name":{"type":"string"},"requeueAfterSeconds":{"type":"string","format":"int64"},"labelSelector":{"$ref":"#/components/schemas/v1LabelSelector"},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"values":{"type":"object","additionalProperties":{"type":"string"},"title":"Values contains key/value pairs which are passed directly as parameters to the template"}},"description":"DuckType defines a generator to match against clusters registered with ArgoCD."},"applicationsPullRequestGenerator":{"type":"object","properties":{"github":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorGithub"},"gitlab":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorGitLab"},"gitea":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorGitea"},"bitbucketServer":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorBitbucketServer"},"filters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorFilter"},"description":"Filters for which pull requests should be considered."},"requeueAfterSeconds":{"type":"string","format":"int64","description":"Standard parameters."},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"bitbucket":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorBitbucket"},"azuredevops":{"$ref":"#/components/schemas/applicationsPullRequestGeneratorAzureDevOps"},"values":{"type":"object","additionalProperties":{"type":"string"},"title":"Values contains key/value pairs which are passed directly as parameters to the template"},"continueOnRepoNotFoundError":{"type":"boolean","description":"ContinueOnRepoNotFoundError is a flag to continue the ApplicationSet Pull Request generator parameters generation even if the repository is not found."}},"description":"PullRequestGenerator defines a generator that scrapes a PullRequest API to find candidate pull requests."},"applicationsPullRequestGeneratorGithub":{"type":"object","properties":{"owner":{"type":"string","description":"GitHub org or user to scan. Required."},"repo":{"type":"string","description":"GitHub repo name to scan. Required."},"api":{"type":"string","description":"The GitHub API URL to talk to. If blank, use https://api.github.com/."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"appSecretName":{"type":"string","description":"AppSecretName is a reference to a GitHub App repo-creds secret with permission to access pull requests."},"labels":{"type":"array","items":{"type":"string"},"title":"Labels is used to filter the PRs that you want to target"}},"description":"PullRequestGeneratorGithub defines connection info specific to GitHub."},"applicationsPullRequestGeneratorGitLab":{"type":"object","properties":{"project":{"type":"string","description":"GitLab project to scan. Required."},"api":{"type":"string","description":"The GitLab API URL to talk to. If blank, uses https://gitlab.com/."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"labels":{"type":"array","items":{"type":"string"},"title":"Labels is used to filter the MRs that you want to target"},"pullRequestState":{"type":"string","description":"PullRequestState is an additional MRs filter to get only those with a certain state. Default: \"\" (all states).\nValid values: opened, closed, merged, locked\"."},"insecure":{"type":"boolean","title":"Skips validating the SCM provider's TLS certificate - useful for self-signed certificates.; default: false"},"caRef":{"$ref":"#/components/schemas/applicationsConfigMapKeyRef"}},"description":"PullRequestGeneratorGitLab defines connection info specific to GitLab."},"applicationsPullRequestGeneratorGitea":{"type":"object","properties":{"owner":{"type":"string","description":"Gitea org or user to scan. Required."},"repo":{"type":"string","description":"Gitea repo name to scan. Required."},"api":{"type":"string","title":"The Gitea API URL to talk to. Required"},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"insecure":{"type":"boolean","description":"Allow insecure tls, for self-signed certificates; default: false."},"labels":{"type":"array","items":{"type":"string"},"title":"Labels is used to filter the PRs that you want to target"}},"description":"PullRequestGeneratorGitea defines connection info specific to Gitea."},"applicationsPullRequestGeneratorBitbucketServer":{"type":"object","properties":{"project":{"type":"string","description":"Project to scan. Required."},"repo":{"type":"string","description":"Repo name to scan. Required."},"api":{"type":"string","description":"The Bitbucket REST API URL to talk to e.g. https://bitbucket.org/rest Required."},"basicAuth":{"$ref":"#/components/schemas/applicationsBasicAuthBitbucketServer"},"bearerToken":{"$ref":"#/components/schemas/applicationsBearerTokenBitbucket"},"insecure":{"type":"boolean","title":"Allow self-signed TLS / Certificates; default: false"},"caRef":{"$ref":"#/components/schemas/applicationsConfigMapKeyRef"}},"description":"PullRequestGeneratorBitbucketServer defines connection info specific to BitbucketServer."},"applicationsPullRequestGeneratorFilter":{"type":"object","properties":{"branchMatch":{"type":"string"},"targetBranchMatch":{"type":"string"},"titleMatch":{"type":"string"}},"description":"PullRequestGeneratorFilter is a single pull request filter.\nIf multiple filter types are set on a single struct, they will be AND'd together. All filters must\npass for a pull request to be included."},"applicationsPullRequestGeneratorBitbucket":{"type":"object","properties":{"owner":{"type":"string","description":"Workspace to scan. Required."},"repo":{"type":"string","description":"Repo name to scan. Required."},"api":{"type":"string","description":"The Bitbucket REST API URL to talk to. If blank, uses https://api.bitbucket.org/2.0."},"basicAuth":{"$ref":"#/components/schemas/applicationsBasicAuthBitbucketServer"},"bearerToken":{"$ref":"#/components/schemas/applicationsBearerTokenBitbucketCloud"}},"description":"PullRequestGeneratorBitbucket defines connection info specific to Bitbucket."},"applicationsBearerTokenBitbucketCloud":{"type":"object","properties":{"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"}},"description":"BearerTokenBitbucketCloud defines the Bearer token for BitBucket AppToken auth."},"applicationsPullRequestGeneratorAzureDevOps":{"type":"object","properties":{"organization":{"type":"string","description":"Azure DevOps org to scan. Required."},"project":{"type":"string","description":"Azure DevOps project name to scan. Required."},"repo":{"type":"string","description":"Azure DevOps repo name to scan. Required."},"api":{"type":"string","description":"The Azure DevOps API URL to talk to. If blank, use https://dev.azure.com/."},"tokenRef":{"$ref":"#/components/schemas/applicationsSecretRef"},"labels":{"type":"array","items":{"type":"string"},"title":"Labels is used to filter the PRs that you want to target"}},"description":"PullRequestGeneratorAzureDevOps defines connection info specific to AzureDevOps."},"applicationsMatrixGenerator":{"type":"object","properties":{"generators":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetNestedGenerator"}},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"}},"description":"MatrixGenerator generates the cartesian product of two sets of parameters. The parameters are defined by two nested\ngenerators."},"applicationsApplicationSetNestedGenerator":{"type":"object","properties":{"list":{"$ref":"#/components/schemas/applicationsListGenerator"},"clusters":{"$ref":"#/components/schemas/applicationsClusterGenerator"},"git":{"$ref":"#/components/schemas/applicationsGitGenerator"},"scmProvider":{"$ref":"#/components/schemas/applicationsSCMProviderGenerator"},"clusterDecisionResource":{"$ref":"#/components/schemas/applicationsDuckTypeGenerator"},"pullRequest":{"$ref":"#/components/schemas/applicationsPullRequestGenerator"},"matrix":{"$ref":"#/components/schemas/v1JSON"},"merge":{"$ref":"#/components/schemas/v1JSON"},"selector":{"$ref":"#/components/schemas/v1LabelSelector"},"plugin":{"$ref":"#/components/schemas/applicationsPluginGenerator"}},"description":"ApplicationSetNestedGenerator represents a generator nested within a combination-type generator (MatrixGenerator or\nMergeGenerator)."},"applicationsPluginGenerator":{"type":"object","properties":{"configMapRef":{"$ref":"#/components/schemas/applicationsPluginConfigMapRef"},"input":{"$ref":"#/components/schemas/applicationsPluginInput"},"requeueAfterSeconds":{"type":"string","format":"int64","description":"RequeueAfterSeconds determines how long the ApplicationSet controller will wait before reconciling the ApplicationSet again."},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"values":{"type":"object","additionalProperties":{"type":"string"},"description":"Values contains key/value pairs which are passed directly as parameters to the template. These values will not be\nsent as parameters to the plugin."}},"description":"PluginGenerator defines connection info specific to Plugin."},"applicationsPluginConfigMapRef":{"type":"object","properties":{"name":{"type":"string","title":"Name of the ConfigMap"}}},"applicationsPluginInput":{"type":"object","properties":{"parameters":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/v1JSON"},"description":"Parameters contains the information to pass to the plugin. It is a map. The keys must be strings, and the\nvalues can be any type."}}},"applicationsMergeGenerator":{"type":"object","properties":{"generators":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetNestedGenerator"}},"mergeKeys":{"type":"array","items":{"type":"string"}},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"}},"description":"MergeGenerator merges the output of two or more generators. Where the values for all specified merge keys are equal\nbetween two sets of generated parameters, the parameter sets will be merged with the parameters from the latter\ngenerator taking precedence. Parameter sets with merge keys not present in the base generator's params will be\nignored.\nFor example, if the first generator produced [{a: '1', b: '2'}, {c: '1', d: '1'}] and the second generator produced\n[{'a': 'override'}], the united parameters for merge keys = ['a'] would be\n[{a: 'override', b: '1'}, {c: '1', d: '1'}].\n\nMergeGenerator supports template overriding. If a MergeGenerator is one of multiple top-level generators, its\ntemplate will be merged with the top-level generator before the parameters are applied."},"applicationsApplicationSetSyncPolicy":{"type":"object","properties":{"preserveResourcesOnDeletion":{"type":"boolean","description":"PreserveResourcesOnDeletion will preserve resources on deletion. If PreserveResourcesOnDeletion is set to true, these Applications will not be deleted."},"applicationsSync":{"type":"string","title":"ApplicationsSync represents the policy applied on the generated applications. Possible values are create-only, create-update, create-delete, sync\n+kubebuilder:validation:Optional\n+kubebuilder:validation:Enum=create-only;create-update;create-delete;sync"}},"description":"ApplicationSetSyncPolicy configures how generated Applications will relate to their\nApplicationSet."},"applicationsApplicationSetStrategy":{"type":"object","properties":{"type":{"type":"string"},"rollingSync":{"$ref":"#/components/schemas/applicationsApplicationSetRolloutStrategy"},"deletionOrder":{"type":"string","title":"DeletionOrder allows specifying the order for deleting generated apps when progressive sync is enabled.\naccepts values \"AllAtOnce\" and \"Reverse\""}},"description":"ApplicationSetStrategy configures how generated Applications are updated in sequence."},"applicationsApplicationSetRolloutStrategy":{"type":"object","properties":{"steps":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetRolloutStep"}}}},"applicationsApplicationSetRolloutStep":{"type":"object","properties":{"matchExpressions":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationMatchExpression"}},"maxUpdate":{"$ref":"#/components/schemas/intstrIntOrString"}}},"applicationsApplicationMatchExpression":{"type":"object","properties":{"key":{"type":"string"},"operator":{"type":"string"},"values":{"type":"array","items":{"type":"string"}}}},"intstrIntOrString":{"type":"object","properties":{"type":{"type":"string","format":"int64"},"intVal":{"type":"integer","format":"int32"},"strVal":{"type":"string"}},"description":"+protobuf=true\n+protobuf.options.(gogoproto.goproto_stringer)=false\n+k8s:openapi-gen=true\n+k8s:openapi-model-package=io.k8s.apimachinery.pkg.util.intstr","title":"IntOrString is a type that can hold an int32 or a string.  When used in\nJSON or YAML marshalling and unmarshalling, it produces or consumes the\ninner type.  This allows you to have, for example, a JSON field that can\naccept a name or number.\nTODO: Rename to Int32OrString"},"applicationsApplicationPreservedFields":{"type":"object","properties":{"annotations":{"type":"array","items":{"type":"string"}},"labels":{"type":"array","items":{"type":"string"}}}},"applicationsApplicationSetResourceIgnoreDifferences":{"type":"object","properties":{"name":{"type":"string","description":"Name is the name of the application to ignore differences for. If not specified, the rule applies to all applications."},"jsonPointers":{"type":"array","items":{"type":"string"},"description":"JSONPointers is a list of JSON pointers to fields to ignore differences for."},"jqPathExpressions":{"type":"array","items":{"type":"string"},"description":"JQPathExpressions is a list of JQ path expressions to fields to ignore differences for."}},"description":"ApplicationSetResourceIgnoreDifferences configures how the ApplicationSet controller will ignore differences in live\napplications when applying changes from generated applications."},"applicationsApplicationSetStatus":{"type":"object","properties":{"conditions":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetCondition"},"title":"INSERT ADDITIONAL STATUS FIELD - define observed state of cluster\nImportant: Run \"make\" to regenerate code after modifying this file"},"applicationStatus":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetApplicationStatus"}},"resources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceStatus"},"description":"Resources is a list of Applications resources managed by this application set."},"resourcesCount":{"type":"string","format":"int64","description":"ResourcesCount is the total number of resources managed by this application set. The count may be higher than actual number of items in the Resources field when\nthe number of managed resources exceeds the limit imposed by the controller (to avoid making the status field too large)."},"health":{"$ref":"#/components/schemas/applicationsHealthStatus"}},"title":"ApplicationSetStatus defines the observed state of ApplicationSet"},"applicationsApplicationSetCondition":{"type":"object","properties":{"type":{"type":"string","title":"Type is an applicationset condition type"},"message":{"type":"string","title":"Message contains human-readable message indicating details about condition"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"},"status":{"type":"string","title":"True/False/Unknown"},"reason":{"type":"string","title":"Single word camelcase representing the reason for the status eg ErrorOccurred"}},"title":"ApplicationSetCondition contains details about an applicationset condition, which is usually an error or warning"},"applicationsApplicationSetApplicationStatus":{"type":"object","properties":{"application":{"type":"string","title":"Application contains the name of the Application resource"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"},"message":{"type":"string","title":"Message contains human-readable message indicating details about the status"},"status":{"type":"string","title":"Status contains the AppSet's perceived status of the managed Application resource"},"step":{"type":"string","title":"Step tracks which step this Application should be updated in"},"targetrevisions":{"type":"array","items":{"type":"string"},"description":"TargetRevision tracks the desired revisions the Application should be synced to."}},"title":"ApplicationSetApplicationStatus contains details about each Application managed by the ApplicationSet"},"applicationsResourceStatus":{"type":"object","properties":{"group":{"type":"string","description":"Group represents the API group of the resource (e.g., \"apps\" for Deployments)."},"version":{"type":"string","description":"Version indicates the API version of the resource (e.g., \"v1\", \"v1beta1\")."},"kind":{"type":"string","description":"Kind specifies the type of the resource (e.g., \"Deployment\", \"Service\")."},"namespace":{"type":"string","description":"Namespace defines the Kubernetes namespace where the resource is located."},"name":{"type":"string","description":"Name is the unique name of the resource within the namespace."},"status":{"type":"string","description":"Status represents the synchronization state of the resource (e.g., Synced, OutOfSync)."},"health":{"$ref":"#/components/schemas/applicationsHealthStatus"},"hook":{"type":"boolean","description":"Hook is true if the resource is used as a lifecycle hook in an Argo CD application."},"requiresPruning":{"type":"boolean","description":"RequiresPruning is true if the resource needs to be pruned (deleted) as part of synchronization."},"syncWave":{"type":"string","format":"int64","description":"SyncWave determines the order in which resources are applied during a sync operation.\nLower values are applied first."},"requiresDeletionConfirmation":{"type":"boolean","description":"RequiresDeletionConfirmation is true if the resource requires explicit user confirmation before deletion."}},"description":"ResourceStatus holds the current synchronization and health status of a Kubernetes resource."},"applicationsHealthStatus":{"type":"object","properties":{"status":{"type":"string","title":"Status holds the status code of the application or resource"},"message":{"type":"string","title":"Message is a human-readable informational message describing the health status"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"}},"title":"HealthStatus contains information about the currently observed health state of a resource"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"applicationsApplicationSetCreateRequest":{"type":"object","properties":{"applicationset":{"$ref":"#/components/schemas/applicationsApplicationSet"},"upsert":{"type":"boolean"},"dryRun":{"type":"boolean"},"yaml":{"type":"string","format":"byte"}}}},"requestBodies":{"applicationsApplicationSetCreateRequest":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/applicationsApplicationSetCreateRequest"}}},"required":true}}}}
```

## Update updates an applicationset

> Update existing applicationset.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/applicationset":{"put":{"summary":"Update updates an applicationset","description":"Update existing applicationset.","operationId":"ApplicationSetService_Update","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1ApplicationSet"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"$ref":"#/components/requestBodies/applicationsApplicationSetCreateRequest"},"tags":["ApplicationSet"]}}},"components":{"schemas":{"servicev1ApplicationSet":{"type":"object","properties":{"identifier":{"type":"string","description":"UUID for the Application Set."},"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"owner":{"type":"string"},"appset":{"$ref":"#/components/schemas/applicationsApplicationSet"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the ApplicationSet."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for ApplicationSets."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"applicationsApplicationSet":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSetSpec"},"status":{"$ref":"#/components/schemas/applicationsApplicationSetStatus"}},"description":"ApplicationSet is a set of Application resources."},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsApplicationSetSpec":{"type":"object","properties":{"goTemplate":{"type":"boolean"},"generators":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetGenerator"}},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"syncPolicy":{"$ref":"#/components/schemas/applicationsApplicationSetSyncPolicy"},"strategy":{"$ref":"#/components/schemas/applicationsApplicationSetStrategy"},"preservedFields":{"$ref":"#/components/schemas/applicationsApplicationPreservedFields"},"goTemplateOptions":{"type":"array","items":{"type":"string"}},"applyNestedSelectors":{"type":"boolean","description":"ApplyNestedSelectors enables selectors defined within the generators of two level-nested matrix or merge generators\nDeprecated: This field is ignored, and the behavior is always enabled. The field will be removed in a future\nversion of the ApplicationSet CRD."},"ignoreApplicationDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSetResourceIgnoreDifferences"}},"templatePatch":{"type":"string"}},"description":"ApplicationSetSpec represents a class of application set state."},"applicationsApplicationSetGenerator":{"type":"object","properties":{"list":{"$ref":"#/components/schemas/applicationsListGenerator"},"clusters":{"$ref":"#/components/schemas/applicationsClusterGenerator"},"git":{"$ref":"#/components/schemas/applicationsGitGenerator"},"scmProvider":{"$ref":"#/components/schemas/applicationsSCMProviderGenerator"},"clusterDecisionResource":{"$ref":"#/components/schemas/applicationsDuckTypeGenerator"},"pullRequest":{"$ref":"#/components/schemas/applicationsPullRequestGenerator"},"matrix":{"$ref":"#/components/schemas/applicationsMatrixGenerator"},"merge":{"$ref":"#/components/schemas/applicationsMergeGenerator"},"selector":{"$ref":"#/components/schemas/v1LabelSelector"},"plugin":{"$ref":"#/components/schemas/applicationsPluginGenerator"}},"description":"ApplicationSetGenerator represents a generator at the top level of an ApplicationSet."},"applicationsListGenerator":{"type":"object","properties":{"elements":{"type":"array","items":{"$ref":"#/components/schemas/v1JSON"},"title":"+kubebuilder:validation:Optional"},"template":{"$ref":"#/components/schemas/applicationsApplicationSetTemplate"},"elementsYaml":{"type":"string"}},"title":"ListGenerator include items info"},"v1JSON":{"type":"object","properties":{"raw":{"type":"string","format":"byte"}},"description":"JSON represents any valid JSON value.\nThese types are supported: bool, int64, float64, string, []interface{}, map[string]interface{} and nil."},"applicationsApplicationSetTemplate":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/applicationsApplicationSetTemplateMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSpec"}},"title":"ApplicationSetTemplate represents argocd ApplicationSpec"},"applicationsApplicationSetTemplateMeta":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"labels":{"type":"object","additionalProperties":{"type":"string"}},"annotations":{"type":"object","additionalProperties":{"type":"string"}},"finalizers":{"type":"array","items":{"type":"string"}}},"title":"ApplicationSetTemplateMeta represents the Argo CD application fields that may\nbe used for Applications generated from the ApplicationSet (based on metav1.ObjectMeta)"},"applicationsApplicationSpec":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"destination":{"$ref":"#/components/schemas/applicationsApplicationDestination"},"project":{"type":"string","description":"Project is a reference to the project this application belongs to.\nThe empty string means that application belongs to the 'default' project."},"syncPolicy":{"$ref":"#/components/schemas/applicationsSyncPolicy"},"ignoreDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceIgnoreDifferences"},"title":"IgnoreDifferences is a list of resources and their fields which should be ignored during comparison"},"info":{"type":"array","items":{"$ref":"#/components/schemas/applicationsInfo"},"title":"Info contains a list of information (URLs, email addresses, and plain text) that relates to the application"},"revisionHistoryLimit":{"type":"string","format":"int64","description":"RevisionHistoryLimit limits the number of items kept in the application's revision history, which is used for informational purposes as well as for rollbacks to previous versions.\nThis should only be changed in exceptional circumstances.\nSetting to zero will store no history. This will reduce storage used.\nIncreasing will increase the space used to store the history, so we do not recommend increasing it.\nDefault is 10."},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the location of the application's manifests or chart"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"description":"ApplicationSpec represents desired application state. Contains link to repository with application definition and additional parameters link definition revision."},"applicationsApplicationSource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the repository (Git or Helm) that contains the application manifests"},"path":{"type":"string","description":"Path is a directory path within the Git repository, and is only valid for applications sourced from Git."},"targetRevision":{"type":"string","description":"TargetRevision defines the revision of the source to sync the application to.\nIn case of Git, this can be commit, tag, or branch. If omitted, will equal to HEAD.\nIn case of Helm, this is a semver tag for the Chart's version."},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"ksonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceKsonnet"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"},"chart":{"type":"string","description":"Chart is a Helm chart name, and must be specified for applications sourced from a Helm repo."},"ref":{"type":"string","description":"Ref is reference to another source within sources field. This field will not be used if used with a `source` tag."},"name":{"type":"string","description":"Name is used to refer to a source and is displayed in the UI. It is used in multi-source Applications."},"tagPrefix":{"type":"string","description":"TagPrefix filters git tags to only those with this prefix before evaluating targetRevision as a semver constraint.\nThe prefix is stripped from tag names before comparison and re-added to the resolved version.\nFor example, with tagPrefix \"component-b/\" and targetRevision \"1.0.*\", tags like \"component-b/1.0.0\" and\n\"component-b/1.0.1\" are candidates, and the constraint resolves to \"component-b/1.0.1\"."}},"title":"ApplicationSource contains all information about the source of an application"},"applicationsApplicationSourceHelm":{"type":"object","properties":{"valueFiles":{"type":"array","items":{"type":"string"},"title":"ValuesFiles is a list of Helm value files to use when generating a template"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmParameter"},"title":"Parameters is a list of Helm parameters which are passed to the helm template command upon manifest generation"},"releaseName":{"type":"string","title":"ReleaseName is the Helm release name to use. If omitted it will use the application name"},"values":{"type":"string","title":"Values specifies Helm values to be passed to helm template, typically defined as a block"},"fileParameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmFileParameter"},"title":"FileParameters are file parameters to the helm template"},"version":{"type":"string","title":"Version is the Helm version to use for templating (either \"2\" or \"3\")"},"passCredentials":{"type":"boolean","title":"PassCredentials pass credentials to all domains (Helm's --pass-credentials)"},"ignoreMissingValueFiles":{"type":"boolean","title":"IgnoreMissingValueFiles prevents helm template from failing when valueFiles do not exist locally by not appending them to helm template --values"},"skipCrds":{"type":"boolean","title":"SkipCrds skips custom resource definition installation step (Helm's --skip-crds)"},"valuesObject":{"type":"object","title":"ValuesObject specifies Helm values to be passed to helm template, defined as a map. This takes precedence over Values.\n+kubebuilder:pruning:PreserveUnknownFields"},"namespace":{"type":"string","description":"Namespace is an optional namespace to template with. If left empty, defaults to the app's destination namespace."},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"skipTests":{"type":"boolean","description":"SkipTests skips test manifest installation step (Helm's --skip-tests)."},"skipSchemaValidation":{"type":"boolean","title":"SkipSchemaValidation skips JSON schema validation (Helm's --skip-schema-validation)"}},"title":"ApplicationSourceHelm holds helm specific options\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsHelmParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"value":{"type":"string","title":"Value is the value for the Helm parameter"},"forceString":{"type":"boolean","title":"ForceString determines whether to tell Helm to interpret booleans and numbers as strings"}},"title":"HelmParameter is a parameter that's passed to helm template during manifest generation"},"applicationsHelmFileParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"path":{"type":"string","title":"Path is the path to the file containing the values for the Helm parameter"}},"title":"HelmFileParameter is a file parameter that's passed to helm template during manifest generation"},"applicationsApplicationSourceKustomize":{"type"
[...]
